---
title: AudioParam.value
slug: Web/API/AudioParam/value
tags:
  - API
  - AudioParam
  - Parameter
  - Property
  - Reference
  - Web Audio API
  - sound
  - value
---
<p>{{APIRef("Web Audio API")}}</p>

<p class="summary"><span class="seoSummary">The <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API's</a> {{domxref("AudioParam")}} interface property <code><strong>value</strong></code> gets or sets the value of this {{domxref("AudioParam")}} at the current time.</span> Initially, the value is set to {{domxref("AudioParam.defaultValue")}}.</p>

<p>Setting <code>value</code> has the same effect as calling {{domxref("AudioParam.setValueAtTime")}} with the time returned by the <code>AudioContext</code>'s {{domxref("AudioContext.currentTime", "currentTime")}} property..</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>curValue</em> = <em>audioParam</em>.value;
<em>audioParam</em>.value = <em>newValue</em>;</pre>

<h3 id="Value">Value</h3>

<p>A floating-point {{jsxref("Number")}} indicating the parameter's value as of the current time. This value will be between the values specified by the {{domxref("AudioParam.minValue", "minValue")}} and {{domxref("AudioParam.maxValue", "maxValue")}} properties.</p>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="Value_precision_and_variation">Value precision and variation</h3>

<p>The data type used internally to store <code>value</code> is a single-precision (32-bit) floating point number, while JavaScript uses 64-bit double-precision floating point numbers. As a result, the value you read from the <code>value</code> property may not always exactly equal what you set it to.</p>

<p>Consider this example:</p>

<pre class="brush: js">const source = new AudioBufferSourceNode(...);
const rate = 5.3;
source.playbackRate.value = rate;
console.log(source.playbackRate.value === rate);
</pre>

<p>The log output will be <code>false</code>, because the playback rate parameter, <code>rate</code>, was converted to the 32-bit floating-point number closest to 5.3, which yields 5.300000190734863. One solution is to use the {{jsxref("Math.fround()")}} method, which returns the single-precision value equivalent to the 64-bit JavaScript value specified—when setting <code>value</code>, like this:</p>

<pre>const source = new AudioBufferSourceNode(...);
const rate = Math.fround(5.3);
source.playbackRate.value = rate;
console.log(source.playbackRate.value === rate);</pre>

<p>In this case, the log output will be <code>true</code>.</p>

<h3 id="Value_of_a_property_which_is_changing_over_time">Value of a property which is changing over time</h3>

<p>The <code>value</code> of an <code>AudioParam</code> can either be fixed or can vary over time. This is reflected by the <code>value</code> getter, which returns the value of the parameter as of the audio rendering engine's most recent <strong>render quantum</strong>, or moment at which audio buffers are processed and updated. In addition to processing audio buffers, each render quantum updates the <code>value</code> of each <code>AudioParam</code> as needed given the current time and any established time-based parameter value changes.</p>

<p>Upon first creating the parameter, its value is set to its default value, given by  {{domxref("AudioParam.defaultValue")}}. This is the parameter's value at a time of 0.0 seconds, and will remain the parameter's value until the first render quantum in which the value is altered.</p>

<p>During each render quantum, the browser does the following things related to managing the value of a parameter:</p>

<ul>
 <li>If the <code>value</code> setter has been used, the parameter's value is changed to the value given.</li>
 <li>If the current time equals or exceeds the time specified by a previous call to {{domxref("AudioParam.setValueAtTime", "setValueAtTime()")}}, the <code>value</code> is changed to the value passed into <code>setValueAtTime()</code>.</li>
 <li>If any gradiated or ramped value changing methods have been called and the current time is within the time range over which the graduated change should occur, the value is updated based on the appropriate algorithm. These ramped or gradiated value-changing methods include {{domxref("AudioParam.linearRampToValueAtTime", "linearRampToValueAtTime()")}}, {{domxref("AudioParam.setTargetAtTime", "setTargetAtTime()")}}, and {{domxref("AudioParam.setValueCurveAtTime", "setValueCurveAtTime()")}}.</li>
</ul>

<p>Thus, the <code>value</code> of a parameter is maintained to accurately reflect the state of the parameter over time.</p>

<h2 id="Example">Example</h2>

<p>This example instantly changes the volume of a {{domxref("GainNode")}} to 40%.</p>

<pre class="brush: js;highlight[3]">const audioCtx = new AudioContext();
const gainNode = audioCtx.createGain();
gainNode.gain.value = 0.4;
//which is identical to:
gainNode.gain.setValueAtTime(0.4, audioCtx.currentTime);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audioparam-value', 'value')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.AudioParam.value")}}</p>

<p>When changing the gain value of a {{domxref("GainNode")}}, Google Chrome prior to version 64 (January 2018) would perform a smooth interpolation to prevent dezippering. Starting with version 64, the value is changed instantly to bring it in line with the Web Audio spec. See <a href="https://www.chromestatus.com/feature/5287995770929152">Chrome Platform Status</a> for details.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
